/**
 * PGP tests.
 *
 * @author tlwr [toby@toby.codes]
 *
 * @copyright Crown Copyright 2017
 * @license Apache-2.0
 */
var CYBERCHEF_GENERATED_KEY_PAIRS = [
    {
        name: "CyberChef 1",
        size: 1024,
        pub: [
            "-----BEGIN PGP PUBLIC KEY BLOCK-----",
            "Version: OpenPGP.js v2.3.6",
            "Comment: http://openpgpjs.org",
            "",
            "xo0EWMQszAEEAMY6F0o6jL6TrVVXDkqJwNVJRR6tQKr+LIt7plEJoaTRVDfL",
            "1jetdhPg+YiE7xZI8ygf6fhsrot4ccUN1QdtwedAz6GH0xjFzpL1i4/7/f3U",
            "ItJ0p1MO4Amy8Tei/AtXXMTy/YwE77V1AMcv7OYFw9va5S0PD87XoKK6rx7z",
            "GFMTABEBAAHNAjw+wrUEEAEIACkFAljELMwGCwkHCAMCCRAar/puuym6vQQV",
            "CAIKAxYCAQIZAQIbAwIeAQAA8/QEAKDVde34L3rvFECzUOFPA5w4w4gbwkg+",
            "YwPa084WvMTdo/wBEiEhj+7P+/5eN/U96yuHD48+Cmm5AHBaaf+K1b2LbNe7",
            "3PP5rV1rMcooUGeIhq7SFw0BdPZTLoCNbkBKFCpvrS/F4SuUQF7g+fVyOyve",
            "zVWew+E41ZC3vsDd63Y3zo0EWMQszAEEANYNy0yka1+c3Oe2U1GqoAHXv05p",
            "VnlHAZ+28JGs8Thq5ns0K8bxI+Fn9CFpPO7Vofrr40V3vweoJVK2Eiq2gN/X",
            "QdxPHckcpYbFKTAZIXt2MAZfb027JxWZid5lyYSCwvY+BK7x5X4jdY5KfbKu",
            "7WDivOkq8MhomSiX+QYDV8qrABEBAAHCnwQYAQgAEwUCWMQszAkQGq/6brsp",
            "ur0CGwwAAIjWA/9WhpbfM+oA08m5XwXgCkuRfTymIkexzn17dZOngTzaGcbK",
            "vpS3QN164XNu229JNKTrsdgn5zeeq3AqhQ63hTMbePajvUYSssHPqKB8qQlp",
            "OUY/rcFEUXMirIkKBGByYBmlz56Ai855wJoSOrZJA6yfnGepyV5ChcG/cEmB",
            "dH/6bA==",
            "=4nW6",
            "-----END PGP PUBLIC KEY BLOCK-----",
        ].join("\n"),
        sec: [
            "-----BEGIN PGP PRIVATE KEY BLOCK-----",
            "Version: OpenPGP.js v2.3.6",
            "Comment: http://openpgpjs.org",
            "",
            "xcEYBFjELMwBBADGOhdKOoy+k61VVw5KicDVSUUerUCq/iyLe6ZRCaGk0VQ3",
            "y9Y3rXYT4PmIhO8WSPMoH+n4bK6LeHHFDdUHbcHnQM+hh9MYxc6S9YuP+/39",
            "1CLSdKdTDuAJsvE3ovwLV1zE8v2MBO+1dQDHL+zmBcPb2uUtDw/O16Ciuq8e",
            "8xhTEwARAQABAAP6A0jnJeW+e1H7J1Tf+cA6n84tBQsd7Td1CYKtCN69/Psz",
            "CBGqpRWMxVuPBwIc7COdU+bje6hhZBJE4F0QUKUy91iQRssy4MzOYmZbdZaa",
            "eTT81MdYb6QPYdTvPBVxjeLJBL7mKB+hM2Z8SvtJMDBdLlprf/XIdZKxD/NB",
            "R+q66OECAPPsaMb+Yv1F30pEJZkATWvUSQS57HzWoBaNGxGkDqcik7+2q3DU",
            "fWe0586HfMFQ3ba1ziNy2SWYJDAqMAe0QekCANAKgQJwww75GGK1RwNFZRoJ",
            "Sb/Jzx3RVbwy1xqfVbadTuvf2+oSBLy/+eGXglwrok08e2BvYWMmhB+uJSJb",
            "M5sCAItUBCJqTszPQPZdIOi7rGomnL2fijBDAUz+kWAWBPcIf8zzexKl7Ebq",
            "dxc621BD5xjDjE7x1Z5XX/Rd2Lt+PvOdyM0CPD7CtQQQAQgAKQUCWMQszAYL",
            "CQcIAwIJEBqv+m67Kbq9BBUIAgoDFgIBAhkBAhsDAh4BAADz9AQAoNV17fgv",
            "eu8UQLNQ4U8DnDjDiBvCSD5jA9rTzha8xN2j/AESISGP7s/7/l439T3rK4cP",
            "jz4KabkAcFpp/4rVvYts17vc8/mtXWsxyihQZ4iGrtIXDQF09lMugI1uQEoU",
            "Km+tL8XhK5RAXuD59XI7K97NVZ7D4TjVkLe+wN3rdjfHwRgEWMQszAEEANYN",
            "y0yka1+c3Oe2U1GqoAHXv05pVnlHAZ+28JGs8Thq5ns0K8bxI+Fn9CFpPO7V",
            "ofrr40V3vweoJVK2Eiq2gN/XQdxPHckcpYbFKTAZIXt2MAZfb027JxWZid5l",
            "yYSCwvY+BK7x5X4jdY5KfbKu7WDivOkq8MhomSiX+QYDV8qrABEBAAEAA/0e",
            "rqd/eunxMJjxlc7nm9+HpBdF9A9zHtx6ukxNdU62WYxkCJxlzdbozm/OAjm7",
            "ul+XigxvvrRhMpb2/iYofTSHnj+6yGGghCic6BtstJOU7qepMrX+IKh3TNEp",
            "YNU8z0E1fSd9fMOx1hnTZwaTroii9CzM0i4YH3pSjze7Ir7cIQIA8Cg8sBmG",
            "IDhe7SBq5xcG2V4iNqiK5gHXbQrcit9/XJFqIeda5Ec7lRjpa6vG5f1xeT1w",
            "KdBil2L4prnD6XDAEwIA5Cy51YIjizFyKormqQNGR1fdAl+6T/qReUcw5Cmw",
            "cDU7tUujZwZz/utmjOcadq8JR2LG6rNwLzeMgDNCCKAOCQH/RX0h3eLXcpWq",
            "jGBH3mJbukSLH/98ybP5LV+4jg0q5iXOOjUIXxFsPElyZZHUBvpoRrKbRG/f",
            "PzOpx7akqEOuDJ/Dwp8EGAEIABMFAljELMwJEBqv+m67Kbq9AhsMAACI1gP/",
            "VoaW3zPqANPJuV8F4ApLkX08piJHsc59e3WTp4E82hnGyr6Ut0DdeuFzbttv",
            "STSk67HYJ+c3nqtwKoUOt4UzG3j2o71GErLBz6igfKkJaTlGP63BRFFzIqyJ",
            "CgRgcmAZpc+egIvOecCaEjq2SQOsn5xnqcleQoXBv3BJgXR/+mw=",
            "=8R+g",
            "-----END PGP PRIVATE KEY BLOCK-----",
        ].join("\n"),
        messages: [
            [
                "-----BEGIN PGP MESSAGE-----",
                "Version: OpenPGP.js v2.3.6",
                "Comment: http://openpgpjs.org",
                "",
                "wYwDmsTgRYVqFPcBA/kBfc7BnEcbKGwac/JOSK6YWzpDERR8NjJT/3R7JDsG",
                "ywJB/ouaHy3e5KGDulALV6pUzcPbCC0CCl5tlFVaFYAj6+BdwR/WCb7dhlRE",
                "x+vw5VKLlY6adSgtvU9aLF0nL0YlU9Pxf9wrPdo3bvxJij7S4mbGS2iybhQO",
                "41ZUtWhOotI9AR/e7f2WHSt8dpl7T9Uq8trAptFWVIZkj+78Gp/8u5o8/mqV",
                "9gxmOGsViKhVZ1b554nwd243IrqlzW2szg==",
                "=prpZ",
                "-----END PGP MESSAGE-----",
            ].join("\n"),
        ],
    },
];

var PGP_TEST_KEY_PAIRS = [
    {
        keyID: "a9510d8fd7e352f5",
        name: "CyberChef nopw 1024 <toby@toby.codes>",
        size: 1024,
        pub: [
            "-----BEGIN PGP PUBLIC KEY BLOCK-----",
            "",
            "mI0EWL7mbwEEANVcA5s+pXliwZBZXvfjy69JlPkX8dWRTZLuqZPz5XKGb9E1RKxQ",
            "jELZ9bBIv/t0HDoiwh1XJok3SRMPzLPHK9lLXaa/l7716CkRddTvkd3cjFA3yAEL",
            "X97+4nPVIajYUPDy6ovCrRru2bXyW2cjHKErlI0GJ37Hbbpj/GXSQL6HABEBAAG0",
            "JUN5YmVyQ2hlZiBub3B3IDEwMjQgPHRvYnlAdG9ieS5jb2Rlcz6ItwQTAQgAIQUC",
            "WL7mbwIbAwULCQgHAgYVCAkKCwIEFgIDAQIeAQIXgAAKCRCpUQ2P1+NS9ZhxA/49",
            "sXqWYoi34HMtHfVejPpPSXrFxY+ZjgM1cMVe5m4cumBeZVVYaEH9/3xDlrhfrlMi",
            "xCRGNqfIRwavIbNWyBshrjVnZ1PR/hvp2P3tV0ciV51lJi6ApO46fsmsWZw84cOA",
            "ejQ1giBjuLuu4du52+MVbcko2yEJ2tOS2WMPnYO7RbiNBFi+5m8BBAClMs6KZuXd",
            "2mhmz3vGcczlA0vv2k7lZjdT7LmbYLt/ir7Hdqg7z7l84wO1qPNQc6pRkLVd1rMX",
            "8fh+RtLUVAuvATpRJCAdaeslcxaH7o0p5DbjrRmiDmnaLDl/S0xMhI137XaKdUS7",
            "ZRuGFZVfqXeFerpbjrlUlhzAcHua8aAmHQARAQABiJ8EGAEIAAkFAli+5m8CGwwA",
            "CgkQqVENj9fjUvUA6AP/b9jZvaQ7w6mdlCvCrFpfp3vBZN1E0vLIMdRKRMmNR8D7",
            "pmZ4RcmMJxjVTLkB6Uc90+9Tbb2ysykQaTTw3YdpmyoGmy3qgH3opd/IdZzEAJyL",
            "oBC+u8G7nATB58m4xmBYL1G5hn8nCBbNAiz1rrbXmWmVExQCVAXp7T50vPBdyFY=",
            "=xCxV",
            "-----END PGP PUBLIC KEY BLOCK-----",
        ].join("\n"),
        sec: [
            "-----BEGIN PGP PRIVATE KEY BLOCK-----",
            "",
            "lQHYBFi+5m8BBADVXAObPqV5YsGQWV7348uvSZT5F/HVkU2S7qmT8+Vyhm/RNUSs",
            "UIxC2fWwSL/7dBw6IsIdVyaJN0kTD8yzxyvZS12mv5e+9egpEXXU75Hd3IxQN8gB",
            "C1/e/uJz1SGo2FDw8uqLwq0a7tm18ltnIxyhK5SNBid+x226Y/xl0kC+hwARAQAB",
            "AAP7BLFYuDDhPrQDIgsdyzzsuIDPbj6G9z9+hsN/sLrZlEFbBt67c95+Sbzm6h1O",
            "SdgcoZiPgJig0L3OyR1kO5ypBG4jhSgbaTKRHjP4KsOWoPuXmL1p8XLzZHOGp3hS",
            "/recAxhqdbbO7uim+nbaPdmby9v0XrMAkFkBTU+D+ZlmC3ECAODTUZ7i+vRD6R3x",
            "NzN2uhomWy94I7SkugTjcTw6BrzvdffFKtW7Yp6MbPdCpRIhuKy/QhG1LCUGwJKQ",
            "vvNe5z8CAPLxrsx6jiFHpzAtUBYNBY5M3t805OYRFbs3mJ3LgsUP0wVOnODqo5TA",
            "anevkFoakvcKJ8d0OlbO0/ewm4wd3rkB+wRQrllfYFfLqGzUlZDP15NKoHFk8T/w",
            "LWg6nDm8pxXlhptaA8V4rVK1HrrPU56GBbzXftqL6iDpbYh9ZPR/U/qoXLQlQ3li",
            "ZXJDaGVmIG5vcHcgMTAyNCA8dG9ieUB0b2J5LmNvZGVzPoi3BBMBCAAhBQJYvuZv",
            "AhsDBQsJCAcCBhUICQoLAgQWAgMBAh4BAheAAAoJEKlRDY/X41L1mHED/j2xepZi",
            "iLfgcy0d9V6M+k9JesXFj5mOAzVwxV7mbhy6YF5lVVhoQf3/fEOWuF+uUyLEJEY2",
            "p8hHBq8hs1bIGyGuNWdnU9H+G+nY/e1XRyJXnWUmLoCk7jp+yaxZnDzhw4B6NDWC",
            "IGO4u67h27nb4xVtySjbIQna05LZYw+dg7tFnQHYBFi+5m8BBAClMs6KZuXd2mhm",
            "z3vGcczlA0vv2k7lZjdT7LmbYLt/ir7Hdqg7z7l84wO1qPNQc6pRkLVd1rMX8fh+",
            "RtLUVAuvATpRJCAdaeslcxaH7o0p5DbjrRmiDmnaLDl/S0xMhI137XaKdUS7ZRuG",
            "FZVfqXeFerpbjrlUlhzAcHua8aAmHQARAQABAAP8C0IAnaGbME4WMkzDyHIbPqTF",
            "s9qX6NMumbthVLY4C4jhgnH9egH9x9sn9rpvm7/Iz2vXUvCdiNgLu/3zQoFYawsn",
            "zpTQREm6CyITOLxyc5TrckodSlx6eoCezvnTzI/PvXrUSSqEP9c9hvcLuKm+aeZz",
            "fclhPfDOL/EQx337aeECAMU0UXXb95hQqSdRMcsGkpoAlAIEM664/S9eBvXrJYWw",
            "1Pfgms7Axi/tZ4ebkc3urRW/YKAt423Ixmdd5rOwIDECANZzoOU8LxreLcLQOoA9",
            "SWswRWUeyQTvH4yskT2iIXen22CO1pp7ruy07vSxHE+yyR3t2ZHKPJU864J39d4k",
            "da0CAJS838KMD8h+Zv1C/jhKkYjpnDRuE+Lj7qVNHCJqsFSzpJAbJ09VpwSGbUso",
            "Ptc/oyXgzb91+sLKfsIwGa7ZysarEIifBBgBCAAJBQJYvuZvAhsMAAoJEKlRDY/X",
            "41L1AOgD/2/Y2b2kO8OpnZQrwqxaX6d7wWTdRNLyyDHUSkTJjUfA+6ZmeEXJjCcY",
            "1Uy5AelHPdPvU229srMpEGk08N2HaZsqBpst6oB96KXfyHWcxACci6AQvrvBu5wE",
            "wefJuMZgWC9RuYZ/JwgWzQIs9a6215lplRMUAlQF6e0+dLzwXchW",
            "=S56e",
            "-----END PGP PRIVATE KEY BLOCK-----",
        ].join("\n"),
    },
    {
        keyID: "02da58ca894c4cc7",
        name: "CyberChef pw 1024 <toby@toby.codes>",
        size: 1024,
        password: "2NSRJYTzgsTVJfih",
        pub: [
            "-----BEGIN PGP PUBLIC KEY BLOCK-----",
            "",
            "mI0EWL7mswEEAMcw0PSzmNfh4MkGwejsyreXb34FqEjYMc1GmswvC5uuLp0KzbC6",
            "HecV1GyyPQ7kKshWVLloShN3KtgSZF7DJ8/Hioiv4Q5HJYPY4AYwqECi+/C4W1FA",
            "tJEbItdEIxw0IgHOX64X5kMptVV9J5bGc7DqkqUHgapXJI+yLZel0s83ABEBAAG0",
            "I0N5YmVyQ2hlZiBwdyAxMDI0IDx0b2J5QHRvYnkuY29kZXM+iLcEEwEIACEFAli+",
            "5rMCGwMFCwkIBwIGFQgJCgsCBBYCAwECHgECF4AACgkQAtpYyolMTMeOGwP+NvLU",
            "GHhHaIFwI+VMB655CiD6QuRWnurcrXq7qZYl3flyBehhZdtgGBx9vynffElEFEFz",
            "cbqzv8unkDTRdPqTA0gM2wOaC/L6Kuy4ErjQD7A4i5rC/IG0ja+3DQeKLShGGtaD",
            "bG0H0mJl7gzlqR3/fxgLxi/JaCtqapjtZDF/GTC4jQRYvuazAQQA5oNC4NeWKBKU",
            "m9H/QZyxKRWGaaQRKLrmSGVkQgJlzo3pnNjJMFUaMcQaJve+PZGay7y9sCOFpumf",
            "6v1ERY+qw4ZOyCRnRqHJOxdLrbTPSmOwIUYkYFkNzARGpdy/FqWCByXDXea5qsb1",
            "DJRT9WUte3Bbx1YvzsqrZMqsExgwgdcAEQEAAYifBBgBCAAJBQJYvuazAhsMAAoJ",
            "EALaWMqJTEzH7woEAKIKQS8bEf8iHaVf7aGEWWOShN10gb+xpWD4V5r8H6hlNpIk",
            "xwQEbj8glTJBEJoD5xO1tdrHmOJ7BVO1d7otdgXpjBAOxn0ngW4MAB8BO+Qa5U/t",
            "M+6yuL8REwE5YUnvIyhgvhiHsBhlLeMNXtwCrF94WyDzyb+hwVwwi/PFtI0y",
            "=djdC",
            "-----END PGP PUBLIC KEY BLOCK-----",
        ].join("\n"),
        sec: [
            "-----BEGIN PGP PRIVATE KEY BLOCK-----",
            "",
            "lQIGBFi+5rMBBADHMND0s5jX4eDJBsHo7Mq3l29+BahI2DHNRprMLwubri6dCs2w",
            "uh3nFdRssj0O5CrIVlS5aEoTdyrYEmRewyfPx4qIr+EORyWD2OAGMKhAovvwuFtR",
            "QLSRGyLXRCMcNCIBzl+uF+ZDKbVVfSeWxnOw6pKlB4GqVySPsi2XpdLPNwARAQAB",
            "/gcDAmIhPcvaoYd359ZKWcYduPFREt173KIgJMOSo4VVl9N2CA0EicF81xC/X+Fx",
            "mr3aZYsqMOpm/GxY8mUyrCgQJTvq36Y/IIMNkTTbgposTX4ESuAUPkZlX6NGTH+6",
            "9wKPTPGiQfxME6QUGw2ROl0mfwh5tIAccKJDJFRrOq1SXZcwJsHemdGPN8pnMrEj",
            "A148htTPGx5usPc1/EJ2AdjKppQ2V+1byXsy37vgEXpXMe+pA9d2zsRsKxgh91up",
            "sfGFsXGBoW/R0JLCe2DDXPGNmYIj3xguhCR6KV7dc7YzgfmXeAX8RUACADYgz5tS",
            "Otot6kau1aIsO3/qY58kGpbOvWblad+302hA9QUginxWISMjddr/zenSRK7cSMnK",
            "g9ezM2QdREw0hG/t9lxLYlKPDZ8DPMOVApOIXHmG3O7/Wh/fvVomRTiz85je2ONn",
            "EgrctzOEZYUn612SpW5lEtxuzNOQamkT0fXnDLZ8wdElxEqcAWjv1920I0N5YmVy",
            "Q2hlZiBwdyAxMDI0IDx0b2J5QHRvYnkuY29kZXM+iLcEEwEIACEFAli+5rMCGwMF",
            "CwkIBwIGFQgJCgsCBBYCAwECHgECF4AACgkQAtpYyolMTMeOGwP+NvLUGHhHaIFw",
            "I+VMB655CiD6QuRWnurcrXq7qZYl3flyBehhZdtgGBx9vynffElEFEFzcbqzv8un",
            "kDTRdPqTA0gM2wOaC/L6Kuy4ErjQD7A4i5rC/IG0ja+3DQeKLShGGtaDbG0H0mJl",
            "7gzlqR3/fxgLxi/JaCtqapjtZDF/GTCdAgYEWL7mswEEAOaDQuDXligSlJvR/0Gc",
            "sSkVhmmkESi65khlZEICZc6N6ZzYyTBVGjHEGib3vj2Rmsu8vbAjhabpn+r9REWP",
            "qsOGTsgkZ0ahyTsXS620z0pjsCFGJGBZDcwERqXcvxalggclw13muarG9QyUU/Vl",
            "LXtwW8dWL87Kq2TKrBMYMIHXABEBAAH+BwMCEFHJC21rjdLnthrJ9pdbFW2+YRtB",
            "Y80jrNzKhEAzmSJ+O0yAX2SuaGUSaJD6W+5nBk8L9+MoarDT+aISHuW8rhQMv2gv",
            "SIwKwY/4nJLltinvKTskoBM5nILjXkvjItHcOpO3A2SCETD+H0+gglhaig7FC/gl",
            "Cn306uSZ/Kdc2VEjOeMLv26srrkZYCU8BqF1GkuJXN4pQQnRKLg5ne6lhg/hD9T2",
            "zE246ZnvfG4GD8nJElFy/hnW1nhZfuKSFpWyKqPyfoy5eBNVMxISYhJbYE9h2sO3",
            "KLzQ03b/b4YGJzVyFaa+sU6z+hZnEtkw+CubpH1UXu6VXT8vMnglNajR1NP50NH2",
            "Wq2z/45Utkmv/cF0SynKYGDTiB+KO4H4i4vK7prH18WkN7nKYdvsE42IYCP2iSg6",
            "jVBTdV5bw6MHi43h5XfgLH1Hw9RU4RMHPMNHMfZ8Yl9us93SYukeOtTlPESqxM55",
            "hSI2+eheYVzUleRe4FNRDIifBBgBCAAJBQJYvuazAhsMAAoJEALaWMqJTEzH7woE",
            "AKIKQS8bEf8iHaVf7aGEWWOShN10gb+xpWD4V5r8H6hlNpIkxwQEbj8glTJBEJoD",
            "5xO1tdrHmOJ7BVO1d7otdgXpjBAOxn0ngW4MAB8BO+Qa5U/tM+6yuL8REwE5YUnv",
            "IyhgvhiHsBhlLeMNXtwCrF94WyDzyb+hwVwwi/PFtI0y",
            "=j2j0",
            "-----END PGP PRIVATE KEY BLOCK-----",
        ].join("\n"),
    },
    // {
    //     size: 4096,
    //     pub: [
    //         "-----BEGIN PGP PUBLIC KEY BLOCK-----",
    //         "",
    //         "mQINBFi+5vwBEAC5WrdZwkz4LG1f5RrKxvY1PxOW3jud+66WV4U6P43Hw3F0ZKf/",
    //         "L8axWnLFEjSgjE8pTfFxVeIRKXqKDhMBnavtZ4AUAd3wJOeIGcJ5LH+UL4u8tbUp",
    //         "WvdRNDdtKkZUanafoHLZg6krnPf+HJDVpbo7Zvz4yoE27A4gDuLo+GU1cEhTWQC6",
    //         "I/Bqlr8sLIdkuNkAIzJnuRx4A2NYPhSmsxSw/xVJtTLW911WQOrF+PERuzveLQP1",
    //         "FyhMmOoCr8on7pSb5G1Z/LzVBowlfMabZ/6FjnsFIcw7VeoT3wPzoOqQfWUSppEK",
    //         "ysoBd+g7NC2kssttWfjmmp5bbtXETLQlSOlI57SUMXAino2zgpBSYZ/dlJBYMAQL",
    //         "vhQ9KxRtcC6TJCquNvg948SAHCrkz8ShWxw4O/xlzvSa1+YFq2PPaIBFtxZlmMB1",
    //         "IltziuPsWiTykStt6HfA99ufi9TkepssfSUk02ns513RF6bw93RIchN3GSieUUMt",
    //         "kMBOw2ITNuSrxzpMDjRCyPp1yyVaWJx9ztakEcFdxkKSCXrXcG+bM/q9tH5S8TTQ",
    //         "Qu+n0jwImuDkgn/9wUzIacZ8AY4407mHPGskek2TfqfRxHrAim8j1xrYmqAaRTEZ",
    //         "r2hbpmTao8VItjWAZroZ97ppCT9FbpWTY/4SgHlCrQP8fxuFztqndZFBGwARAQAB",
    //         "tCVDeWJlckNoZWYgbm9wdyA0MDk2IDx0b2J5QHRvYnkuY29kZXM+iQI3BBMBCAAh",
    //         "BQJYvub8AhsDBQsJCAcCBhUICQoLAgQWAgMBAh4BAheAAAoJEAw4Rj8SrQJmcs4P",
    //         "/18Iz1GDjiqPJKOuzjUYjxXg2SQA6bk6AN0Rf00uipyKJQAMQQjdQbrhL9xU8nQt",
    //         "aNkRe7lWMoLdAgUwm4AeTPTaAqqueeJVnh+0FANfQcua1nBfokO3UXIqStpzR/mj",
    //         "p5E+iXadL7Ir94Kbvoe2ws+tnpWlgLttFb9wSOwfurF6UIh6wlDzdHW7V7P5x8wd",
    //         "eDfQHzQGAVUbObIFiV8ct5bIEBrb3c43L0RsKHuE/t+ze9CLtp0kzucix4lKZwf8",
    //         "lK7+0SWBNxnyYEmJs6AWtpJ6vh1LVxs/gHbWfkv8Vc7Q5+WxmknMp7DIqwKOPaTZ",
    //         "XaQP3pmyL07JoKvQrKflAH7XVYCWM9w/7OUGvWIN+qTlOgtUroKxkamT/K9Z0Q3M",
    //         "HXhf+HpS45wmcUR+7kqVGK1mnyJOp+KpYmFGHqvT47JR28jVHXygrYdgyCb6EiUF",
    //         "vKzv1QRYT+CeCge067Z5iMNM63/WxEuOuTqdYjSZqnZb+d2DCXRf0pdTZezAqfAf",
    //         "VEut0irsRl6ia0cPkdZ+BnKNkCOG2XlZvCtUzPJy/Q5NXWzLhuJcApxYXQrg14tW",
    //         "lRaQLwko+ABhzjJwWNhMLl1vlQJ0+UZmtGpRKP4C2yUZaJM4hJEkwlRUYvRpu8dW",
    //         "lDPgRCZQAuHYUcyEfB44nFMiTOMcHPVAHHjhS9SA4J5ouQINBFi+5vwBEADC9qhd",
    //         "mTnBTLKP56mspLePVR6eJro+cq/q1LbTNcf2HpBLH929te3gKka8ypI1R0hBAdng",
    //         "CmR9oPaG69KHOAfsjd6sgv0em62v1jORQY/LN27M9c58U1lCZVjx1WFR/O0JO3mZ",
    //         "v0ZWHrWOZF4xJyCldJTEGQeWg5k/s0xN31E6D4gFwUFx618FdukLMw+iBPmFrMog",
    //         "kx02izFMl4mqRFZS0vJiHKvmlTySXiQI1pf+izhz10jD1wOIPVyrlIrA/E9wfYao",
    //         "jD7ZMFwwSXN3SAuVEx079f7XrZ2eP2WN0hsu9TvFNiwTVGpJNp3rsROk4yyQyi94",
    //         "n6ykSF3jXKfoLZYklzkWZWYVVSVcsO6MHaK/3I+bGkmF3l0L/aTF85hwUPsOLqKD",
    //         "uWnSE26DJLAwIhZCo0y4d3yNOVI8BVxZvwB7Q1oV7DQY9LQgM7jPxH/Um4wFl473",
    //         "w+5VisYrUlMLujrFmNFWmY7jdD98S+C2L/09rqvVeszWWXG5CpaJhcJ46BqDTTQo",
    //         "GqXY/rTft/f3dLiuD4KfCYggbx8DEz3YW2Zw4siWkyvDDUaswMPDxmhlo9zV/mQb",
    //         "4dzS5+y72jEDe67r0FTr2vIqAMDiDz1z3Lq0WzbEyYWQv0Viput3mFYbRLlFbrGM",
    //         "XSjcqbS/YeisQu2zWqN+F+5cFxiPtQ4SJyPeUwARAQABiQIfBBgBCAAJBQJYvub8",
    //         "AhsMAAoJEAw4Rj8SrQJmOSwP/ROtXAjM1k2UPfdBGsVCV4kRj2ej9zeR+/fOEzU2",
    //         "Aoz99eqd6ZQv/Vm9tSJKCC9WOFyWRSlZIo0ZNu3r958KWHdIChwCO4ATfbRqd3P9",
    //         "SG0OpwIl3/VdRW8ahgjTrU7B+6SzfWu827emN9mkln5eFXHEn1hXODDdAc2Mtmp6",
    //         "qwFY0VbSKpUbdWh5PKbnAJqS9zShYhKM5OsV6p5SK3JWvXk4rC2Qxt0WRgUDt0vz",
    //         "ERSzZJE85vmTeImrLXrqOC0TnJy6XxKz3jex5+ZAW+qE9CFUClqTQC+oALB1nj2p",
    //         "55STLEWGCTYLY763yr7qhWsV9lB21/sHzbcnXSFSfUCyBWTJdxKs4AmrIzhkdbaq",
    //         "gI3vGi2L/OY0Lh74XNEVuJBlD88ohEBN47EIon6DYt0no9qNn4nZBn1f/D6Vnmn5",
    //         "wEa6tPhS1R0aRAIiviWH2jH+kEGN3F+NoVzhPC9pZgOQJ+NgQiwPP2VOHzMPDQSZ",
    //         "/mxTnhkQwYYZzzQXMlWGOg/4u/sFdm5PSHkQFaRFoUEvVQPdPghPobfusLs0DVc3",
    //         "60IOK05Sb9tnCafcqAakBe8kHF044+mI8HhgzkgEC26TWBq7vivP+GDQqijNpOxQ",
    //         "GdLnsTUnuntARuYntv55Fhauj2eFEvz2i1rQpSuiJya+o+bs9fzekrdWhPLptINb",
    //         "QsAB",
    //         "=s/CE",
    //         "-----END PGP PUBLIC KEY BLOCK-----",
    //     ].join("\n"),
    //     sec: [
    //         "-----BEGIN PGP PRIVATE KEY BLOCK-----",
    //         "",
    //         "lQcYBFi+5vwBEAC5WrdZwkz4LG1f5RrKxvY1PxOW3jud+66WV4U6P43Hw3F0ZKf/",
    //         "L8axWnLFEjSgjE8pTfFxVeIRKXqKDhMBnavtZ4AUAd3wJOeIGcJ5LH+UL4u8tbUp",
    //         "WvdRNDdtKkZUanafoHLZg6krnPf+HJDVpbo7Zvz4yoE27A4gDuLo+GU1cEhTWQC6",
    //         "I/Bqlr8sLIdkuNkAIzJnuRx4A2NYPhSmsxSw/xVJtTLW911WQOrF+PERuzveLQP1",
    //         "FyhMmOoCr8on7pSb5G1Z/LzVBowlfMabZ/6FjnsFIcw7VeoT3wPzoOqQfWUSppEK",
    //         "ysoBd+g7NC2kssttWfjmmp5bbtXETLQlSOlI57SUMXAino2zgpBSYZ/dlJBYMAQL",
    //         "vhQ9KxRtcC6TJCquNvg948SAHCrkz8ShWxw4O/xlzvSa1+YFq2PPaIBFtxZlmMB1",
    //         "IltziuPsWiTykStt6HfA99ufi9TkepssfSUk02ns513RF6bw93RIchN3GSieUUMt",
    //         "kMBOw2ITNuSrxzpMDjRCyPp1yyVaWJx9ztakEcFdxkKSCXrXcG+bM/q9tH5S8TTQ",
    //         "Qu+n0jwImuDkgn/9wUzIacZ8AY4407mHPGskek2TfqfRxHrAim8j1xrYmqAaRTEZ",
    //         "r2hbpmTao8VItjWAZroZ97ppCT9FbpWTY/4SgHlCrQP8fxuFztqndZFBGwARAQAB",
    //         "AA/+Kw6fuQIhzyTC45vc9W3yk7vrWQiW4MQuck4ybK2Gyfjkyhz3yZfXmCtirdTk",
    //         "1MbDPN0WUTWaJlJ0XM2YLK/r2GJKplsoqzhncH5LZsqneEzzMQsk4k53VS3EEl/X",
    //         "ppR0qfAjvdOP4Mm98hHAs2CkOlhaO5EPIysCvP+4RlYtbJSAuJvcR2FB4ADUt/ZA",
    //         "HW2zOwzyEJY3vslKspz5PyAqllMrJswo2zbrP7Yk04hYt72+0oWyfaS7f8+lzKn5",
    //         "U/1gGDagEF9dnj6/H5Y0rLUjsvK+MRsAzmfO0H7l9BpVYus+J276En+5HU41bEta",
    //         "rv+5sdVMtIUGdEby8X6/+klNp3S3Uiy5FxP0bMV2XfeudOsbXg5VvTW3XC54EfYZ",
    //         "55nnb3IgWgd2EM4rZNmA0ayUa7Fbht1haMcH+DG9KV9P5e+K+iQdOU86SNlEje/O",
    //         "Urt+VrsuJy5DGwNMK8OgM1u6S1mbM1W+KEu5WEHdvXIoC3vTsfdoik98mSiGQcl/",
    //         "HQy6pjIyUDrbm6rOgYfpWkNRBJ7oQOPtzO3s5caIJGMp3Kf7rSQl4m3x9xzhoixs",
    //         "8jnvmOoSpnbsmOr4GX0dB8e3pw+7Mo3tvZOH/47YwmPbIYgt8dG7DL8eyLQHImvI",
    //         "OLt8/LbbZLDz5W4ifTu05aMqyKEiR73lJ0ItAwrv+x69z8EIANlNYvhfKJl6qlR0",
    //         "VmoAi28DZ/4VwJBzHnWTIJsYiRfWm36DiXwex8MGz3Rt7lzvz/+GBeohbm+ibYaQ",
    //         "ItPlT9u9zatlmTCf+1267UowwSNtJTtypCyNpfULdP07AYVLTYVbHdP/ULxsLOv3",
    //         "qBkAQHthLZ3bZSGfX+fsbCONlr70+XHWiw7zOAu3qGQjlhN4NbEqycbTo3pFg/0s",
    //         "DAe0TogTdj07gTj7olGJSZePpOUsyPIBbchm1SSRg2ErtPReh6sTTpFQd4LT37mV",
    //         "VJLzwPVz0/wZELRg8qN2HqIESzCVbJ8r5qnHA6jWORlt6AIZch63NFGX+ji2Gbwj",
    //         "OweZDWcIANpc2kCLduh/C/kwPWED3ikLGkXG0YKSbMUJ1c8aHRYqNpy/S799fimV",
    //         "TV8CkWfOo5lMIVMhXPaUDY4RxalM+4QorKjCFS1EJR125jyLWxnIM4essLJhDlUn",
    //         "FI39cal2cWeB4POYpiBHv2rDiEUStwWlTuILEROrnewEEzzCMCRBxp+4exqNYwmm",
    //         "QcnHkMAoFZepR8lgY4hzjG5STtCPFJuHbf4LwzQetxgpAk7M5iyyiUNUOT3oma/n",
    //         "g3OFQ5sPdUUIdO7zV4tpe6xBPPXmsvcbbOZFZTpUoVR1BBAagfdWOE42bkmi19Kf",
    //         "eVPojg4Tx929miADqnEaZ4AItX9xKi0H/0AC4fXOmPMzZBLz84D+5XPRVObQt0DU",
    //         "ZlBl5R4uhKNcJOnvaJethelRmol5u8Pp3OGVr0VzdUdqzO9/Tq6u3RyxdRzRRBL5",
    //         "40YVwba6BST4fkKmrhK0O5JebmP8R1ZHU7mayq+9xENufCFrFSrF5nZu4EVt3YdV",
    //         "xVkT4Ck1MvlQAFpewBLJ18bYSODG0Na6wsfbvzsNeDoHs7cFtEFbKayDj6eM97iS",
    //         "RHYmkt76Cyu817kGZhuxDSk91VsDtXcPPxGQsh+GG2Joc4/sH97NWwt9gkIreDJC",
    //         "BXEXfuomf2edCrAF78K03yuXObfPwxECWgeGrv+P8OsY2aHe7PfVfvJ8NrQlQ3li",
    //         "ZXJDaGVmIG5vcHcgNDA5NiA8dG9ieUB0b2J5LmNvZGVzPokCNwQTAQgAIQUCWL7m",
    //         "/AIbAwULCQgHAgYVCAkKCwIEFgIDAQIeAQIXgAAKCRAMOEY/Eq0CZnLOD/9fCM9R",
    //         "g44qjySjrs41GI8V4NkkAOm5OgDdEX9NLoqciiUADEEI3UG64S/cVPJ0LWjZEXu5",
    //         "VjKC3QIFMJuAHkz02gKqrnniVZ4ftBQDX0HLmtZwX6JDt1FyKkrac0f5o6eRPol2",
    //         "nS+yK/eCm76HtsLPrZ6VpYC7bRW/cEjsH7qxelCIesJQ83R1u1ez+cfMHXg30B80",
    //         "BgFVGzmyBYlfHLeWyBAa293ONy9EbCh7hP7fs3vQi7adJM7nIseJSmcH/JSu/tEl",
    //         "gTcZ8mBJibOgFraSer4dS1cbP4B21n5L/FXO0OflsZpJzKewyKsCjj2k2V2kD96Z",
    //         "si9OyaCr0Kyn5QB+11WAljPcP+zlBr1iDfqk5ToLVK6CsZGpk/yvWdENzB14X/h6",
    //         "UuOcJnFEfu5KlRitZp8iTqfiqWJhRh6r0+OyUdvI1R18oK2HYMgm+hIlBbys79UE",
    //         "WE/gngoHtOu2eYjDTOt/1sRLjrk6nWI0map2W/ndgwl0X9KXU2XswKnwH1RLrdIq",
    //         "7EZeomtHD5HWfgZyjZAjhtl5WbwrVMzycv0OTV1sy4biXAKcWF0K4NeLVpUWkC8J",
    //         "KPgAYc4ycFjYTC5db5UCdPlGZrRqUSj+AtslGWiTOISRJMJUVGL0abvHVpQz4EQm",
    //         "UALh2FHMhHweOJxTIkzjHBz1QBx44UvUgOCeaJ0HGARYvub8ARAAwvaoXZk5wUyy",
    //         "j+eprKS3j1Uenia6PnKv6tS20zXH9h6QSx/dvbXt4CpGvMqSNUdIQQHZ4ApkfaD2",
    //         "huvShzgH7I3erIL9Hputr9YzkUGPyzduzPXOfFNZQmVY8dVhUfztCTt5mb9GVh61",
    //         "jmReMScgpXSUxBkHloOZP7NMTd9ROg+IBcFBcetfBXbpCzMPogT5hazKIJMdNosx",
    //         "TJeJqkRWUtLyYhyr5pU8kl4kCNaX/os4c9dIw9cDiD1cq5SKwPxPcH2GqIw+2TBc",
    //         "MElzd0gLlRMdO/X+162dnj9ljdIbLvU7xTYsE1RqSTad67ETpOMskMoveJ+spEhd",
    //         "41yn6C2WJJc5FmVmFVUlXLDujB2iv9yPmxpJhd5dC/2kxfOYcFD7Di6ig7lp0hNu",
    //         "gySwMCIWQqNMuHd8jTlSPAVcWb8Ae0NaFew0GPS0IDO4z8R/1JuMBZeO98PuVYrG",
    //         "K1JTC7o6xZjRVpmO43Q/fEvgti/9Pa6r1XrM1llxuQqWiYXCeOgag000KBql2P60",
    //         "37f393S4rg+CnwmIIG8fAxM92FtmcOLIlpMrww1GrMDDw8ZoZaPc1f5kG+Hc0ufs",
    //         "u9oxA3uu69BU69ryKgDA4g89c9y6tFs2xMmFkL9FYqbrd5hWG0S5RW6xjF0o3Km0",
    //         "v2HorELts1qjfhfuXBcYj7UOEicj3lMAEQEAAQAP+gNqBbQbPSYDwtNppNCvfcDB",
    //         "JoJx09ceHl3dZb+NyeJR0ghkFsz+BPFlAXdy5gaQKKrCw978L5r87kmZ6EY9QUjv",
    //         "ib5kTixytiLwfFdchOPJJQ6VILg6pBiD5SqEUxT4JJUseR+rzX6FQSas3p1maFhI",
    //         "Egbbwq9Bv2BHMoc2lESRBbpxZ5pSxdzhookeAXW+jTloYjhvJcF7xIbpLHGn4AnJ",
    //         "RJIFRdle3wBX17Jel6t5zVOcqds2xmAPZbJiLTUzS0IsCzyjtWy2P8G0t5SXgA8X",
    //         "QO7ONa1EjrsOXyfm+Fo6fyvKnBD77HSQbp7fAKS65F/mD9jBQGkMFLYo5uPWUIfB",
    //         "pt31amOANPnIDJpauCy79iGfG1kCQ4kI1gwmO+chso921BtrrDkJ/uQZodzzJSDK",
    //         "8wc/Pfgru390ZSjniDmn0i2dpNUXjlsF9Hray1iOfjm6YmyiMEa67iqsRaq/3eyw",
    //         "OHTdocAzkxBw+gKnqx0Q7W0z3t8bAy6qFoZLG7LIXd7qGWfd0h/WmOZrl2O4gwqy",
    //         "TTLzldwO1lFAO7fE415rN1qOLhvHb7nRqLjPRhCnflL8LlvPP4G/VszUU9dnIp9w",
    //         "N8fVioVp0EgPLrPFWZiacwpXBv3X3N7OpzfCAUVf6iYpaKF98ZTrAbPHmchRcTVj",
    //         "zdqPTT5mhHdP85EpAehpCADMD/gH3oVeLyUpK6206WGEmBbd5+KzFVT9ADSP6yJi",
    //         "EDtw7O8ko1xDybeu+ix2DAlae4R8sWHEYGmrjqz8Bi/lWkime5UOoFIIhqLglByV",
    //         "Dbr3yZCI1UdgYtIOYioEmY7vFUk+ycPDhDC1eqXR+iuBoR7HsUuqfQncUctXCutg",
    //         "4oS69sSg4kDYmM/t3Z/NWU3zY6Z1+++Hf6/rIFf7vGKRN0JOJIiHYRirrJOGrPhY",
    //         "0BNf1wm3tfqwfuC7k6q//9AecX6TG1FG/s57b4L56jsuqLP2hJnC5f483roQdxvE",
    //         "ngk7Vi7Qt5XHwda1pPZMw/YhboXTmrdN255SIb+Q323NCAD0ldYa1MKdjn76jVGC",
    //         "2lrRkLQ3G/Etr9FjvPWOMhfRirjagWcgMZgKGfR18TgD6KE2tvyZo6uPfQtna/tG",
    //         "CNNsnBID0VV9XJ3+GYhIxiqQ6g4c396BmvgvZI1wLhHrm+KJW76rKFlQ+qQiO1F/",
    //         "mODx0hn4UHyoDRHvxOsGflMlX0PNIYN4uaHziHcuJrCaVtpFVhXFaCJ5MpmYeIKL",
    //         "IWZMHcKQ3qP726Hmkrv17UKQWjRXnYFWP07YW3P2Y2krp7GNoRd6njL9owZjOvQ4",
    //         "Y1UaMdb2P3Npg3P8cl1Xddn8FgNrKyHJ6qcwLetINSfSSAnhHiLpSYYOkMcPc2YD",
    //         "jVyfCAChN4+S79VLj+ARsmX7m8r84tp/SkxFDoSUt3x6YaQR4JSqh4PxZZiK8Vty",
    //         "PK2xQveS8cbtn56tp89aLwNs3yydcJ9epdNggw22IXRg1nFGCjxg68LZiggFgOu4",
    //         "5ki0oLPP9VHOdIbWTynRew1rp4510A9cI9+waLTQtboN/ffJAytIZ39AD924ZF/6",
    //         "GZDTg6Y2/N/VAWYMcyXKaK05EwTdYdHQ2Z4Txv1ClyQtMXPZY8GLZNWGNRXtyOlB",
    //         "D1RUMvtrIif4Yygupr4tcwu5T4WeqZ+XcCOxMfunYRuWo3P3FqSWZhpOzSzDn4p+",
    //         "dx263Hg+PeG6zrJ9atcQnr3jBMZ8jBqJAh8EGAEIAAkFAli+5vwCGwwACgkQDDhG",
    //         "PxKtAmY5LA/9E61cCMzWTZQ990EaxUJXiRGPZ6P3N5H7984TNTYCjP316p3plC/9",
    //         "Wb21IkoIL1Y4XJZFKVkijRk27ev3nwpYd0gKHAI7gBN9tGp3c/1IbQ6nAiXf9V1F",
    //         "bxqGCNOtTsH7pLN9a7zbt6Y32aSWfl4VccSfWFc4MN0BzYy2anqrAVjRVtIqlRt1",
    //         "aHk8pucAmpL3NKFiEozk6xXqnlIrcla9eTisLZDG3RZGBQO3S/MRFLNkkTzm+ZN4",
    //         "iasteuo4LROcnLpfErPeN7Hn5kBb6oT0IVQKWpNAL6gAsHWePannlJMsRYYJNgtj",
    //         "vrfKvuqFaxX2UHbX+wfNtyddIVJ9QLIFZMl3EqzgCasjOGR1tqqAje8aLYv85jQu",
    //         "Hvhc0RW4kGUPzyiEQE3jsQiifoNi3Sej2o2fidkGfV/8PpWeafnARrq0+FLVHRpE",
    //         "AiK+JYfaMf6QQY3cX42hXOE8L2lmA5An42BCLA8/ZU4fMw8NBJn+bFOeGRDBhhnP",
    //         "NBcyVYY6D/i7+wV2bk9IeRAVpEWhQS9VA90+CE+ht+6wuzQNVzfrQg4rTlJv22cJ",
    //         "p9yoBqQF7yQcXTjj6YjweGDOSAQLbpNYGru+K8/4YNCqKM2k7FAZ0uexNSe6e0BG",
    //         "5ie2/nkWFq6PZ4US/PaLWtClK6InJr6j5uz1/N6St1aE8um0g1tCwAE=",
    //         "=THWI",
    //         "-----END PGP PRIVATE KEY BLOCK-----",
    //     ].join("\n"),
    // },
    // {
    //     size: 4096,
    //     password: "yhyUeUqTeKqamu8U",
    //     pub: [
    //         "-----BEGIN PGP PUBLIC KEY BLOCK-----",
    //         "",
    //         "mQINBFi+54YBEAC9mzH9WlzMfIv6h7BET4J/dBp6yhOoi+f082uerSaStN+WLTbL",
    //         "HtW7T5i760lS/uZanQYz2jqTtvTO/pMcTIqwiH7TZW54vQmwf26uoWtwq1nRtajP",
    //         "w8/lBzw81ZDKGIBLudEMvBurdyf980FBRqeshHvBQrIx11FHqe0dCMRzUNdUImm2",
    //         "Yb14EsPjgc6TMvnXPptBadx2vPQ2rUoPHgV1OmjYEWl4bqIUK7Xdo8WSnoof1K7T",
    //         "VOy9hPvV9QLC9hXpkSKcXLaXABnb6OPNv9t2z/ngrgLISY2K93h/LJf/NYhmxMwZ",
    //         "O3DsVvUNHZr/mcoKaLavnXJtrd5Dvdekee0YidmzfKmNn2c8yVWIIjF3+fqtfndF",
    //         "BPRmsTYWMZUOL3DLQ4wkuqj8mLV5aoC2HWmkJ/+U/MltAiKFwSUvh2omp1Lme+Sr",
    //         "qibtSYqhiXudOv4kToFBWcw4f1c7WafuMl9ALRax/APV+aj+ZWNNMRxDi9ze/Bgk",
    //         "Q6ADv+wwWFDg9nYLpIhl4UzgAkMI4pm+vCS+8C+TDw9N0G80cYWp4xI6ZXrzXpek",
    //         "az2mw7KDJYxX6+EHCBzrj9ajo2eofc0c5O8vftHNSiWPk9cwqSpLY8nrBdKMAjma",
    //         "tClaKz8eaRUZ6nMvtnIwuyRF8/v0wJxL8kRYv94AQM2L7hwWUCXfqrflnwARAQAB",
    //         "tCNDeWJlckNoZWYgcHcgNDA5NiA8dG9ieUB0b2J5LmNvZGVzPokCNwQTAQgAIQUC",
    //         "WL7nhgIbAwULCQgHAgYVCAkKCwIEFgIDAQIeAQIXgAAKCRBkilUOeZKyXjKMD/9+",
    //         "gRQ9FobqcxUfxn0dZDDuivYTKsgZgIaTOV/tEGj9WhhNf2oI8I4qeEVY7YN/yoHc",
    //         "lVjbKvDq27hnqtbC4ELUln9O7SNb+Li5ejBh4LOokrYv4rzDB5ih7vShseCAJyLc",
    //         "oppyWq83fahCrR/qd6uZsKEqkBgaqmn8xNOewQGUEabAUn/A+dRgA4HLaNnIm5D0",
    //         "atOZhq4YcpqVJtueFSmE5q50lfbBBrzl0GrGZuleAo3j62Qb1uSHa+nXGw5LKtcd",
    //         "6Lyodx4zoDNhx6JuLz5eWZ1mPjtsEdN5SdscvNXI92Q/AHXSSR2dVS32t6nTi+Sv",
    //         "no5Rm+XVepkoT53EeYEZY71ptfgJGtKWRwCPv02CCEoeCBE8BqVrEgHnZ2qNeQ3u",
    //         "BHbgqqhppllN/Eqp+ZMlZEvAG3AbdVb7nFA2E93k21ZeqHae5sIifNGZgGpBui1M",
    //         "w2Nrjd5aw5ic7NrQfXnvoSPS+fh2jbHRJpPnbIiudKjGcTlaI4tuucun/BPT3XhV",
    //         "23RoQV5NK9AbaLiq+xCURmpwel7vgNpadbnPAlsw0hnMIHB6eZaV+6YXBHL9AWZI",
    //         "liodLXYDylnMz0uxQIAZdWl28hNu1LtNMvnZ9DGf0WX2d/xKxxDvIU+XcN4pQFHS",
    //         "4wDU8qVPc/e9Svnup2NaSaSbIwcPBA3HO1OTzxRWtLkCDQRYvueGARAAz3l2fXMB",
    //         "I5TNXKeybXyK4eRlBIXrvzoEt/HcYEOS/Lmb8D8Cq56ztHsS9ttlmJ0YHUexjZDZ",
    //         "S6+NvHos35/xFG5KeRRCfpXdyccdNDl0YqfAifDl6n+TrKacPNr/D0DTTVTjrdKJ",
    //         "1ckerNeoJUBnk5j8C+ybr5uOdo87SIABjWSJwR6G77knCmwzDtBpNa+wW7eEgqsw",
    //         "UDiCkZB95eCUILlH38Ne1w4m2NIeSQ8+hC/0nWgHKOT6IBHB4k1CJuMj+zbULVOS",
    //         "7RHIekJsqN3yCcaUU0q6QgXpcyLGvFt0i+GWKmj0d+KRSjkp5wOASet+mp8k4m80",
    //         "aG3B8sqhkUSDCLWNv/T8atm/xdGdU8/x0ejx/17O6faEh0vZp7PEAmFhvcCz1lL3",
    //         "b+xVpLBsWNTaoPdN1NdTf+fJJ6o7JwVexffCbPMJA8UygxYc9qc5ez91U33A6/eS",
    //         "Q9gnB8wHkXYog8E695tAhkHs+dwi7PRqnngQPwo3qN81zpyDUYcljqNhyVTClMEH",
    //         "ficx58OhuoDnqKnI78TlvS7ZO+ktuAVYQPJ03JITay81x7kRhuz+ipEijr12VwuR",
    //         "VPgof4827jPuQdE/vK60SevvhlgABqd42y630HzyiVLkerMLdr+Hk4qLQLZ48MOA",
    //         "toLkPJw1U97BmXmmYa0tc3Srjk5f1I73b8sAEQEAAYkCHwQYAQgACQUCWL7nhgIb",
    //         "DAAKCRBkilUOeZKyXl4QEACFauLQ9motTvRiUkWaGHeMNRxR/K2UmWAtGcxPY3Ni",
    //         "SFbgRlx4n47+GD5KSDAjQ0ylypxKM1XFOCFCMtXscnKw+fz8lqwhtrgi7VQcI9Yu",
    //         "HpNNdl3L+ozYE96XVO+R7VJt8prq7DkpzW5CASd6y368eyiVpBbtfEBuzLZ2l+W9",
    //         "lM+Ej0rvr/LBsoGIszJ2FEOFe9eoknKc6KFAMizQqvszaSyDq8yi8b2hkp8JCM2k",
    //         "E7FKNxOQ6e3p+aLFDrLKixeUWKgpAsNcNJ+BG3muuIT8sgO5g/Ku5LooqJpzDtC4",
    //         "anjC2fUJCNfEADvIyLiVOXzy7ak0o76M9IG2khW11JtiEKpJhiaRhnK+bPq0Rigt",
    //         "nVK3U534WiLHrw2g56BdfLgIXPqxQ9yZ/4vq+nnWqc+U1VUG9YLvphWuw19bwnU6",
    //         "sow1i6DUIEXuvV2CXs1CyNenRm5kQCNotEdKdiUHm8+VGDqZWAM5GG/dOSfn0kKa",
    //         "CcLZY5vSK475MQ4oqpMuESQJdqaSQoUIBKlxCbsRFKYrWnA7SXcBUIq8EhbLfNfb",
    //         "eiexv3S2HsWC+UsgbkE2qTlPsjKC5yiNm6AVYd+Y1jhKG5R3mLIREaUjfEQFS9Md",
    //         "NDy51FclbPvWDW9ogmA2iM1Bscl4jA0e6Yzaokel3Kgplk47EDhE/cULxDx+gCxh",
    //         "Pw==",
    //         "=rBvJ",
    //         "-----END PGP PUBLIC KEY BLOCK-----",
    //     ].join("\n"),
    //     sec: [
    //         "-----BEGIN PGP PRIVATE KEY BLOCK-----",
    //         "",
    //         "lQdGBFi+54YBEAC9mzH9WlzMfIv6h7BET4J/dBp6yhOoi+f082uerSaStN+WLTbL",
    //         "HtW7T5i760lS/uZanQYz2jqTtvTO/pMcTIqwiH7TZW54vQmwf26uoWtwq1nRtajP",
    //         "w8/lBzw81ZDKGIBLudEMvBurdyf980FBRqeshHvBQrIx11FHqe0dCMRzUNdUImm2",
    //         "Yb14EsPjgc6TMvnXPptBadx2vPQ2rUoPHgV1OmjYEWl4bqIUK7Xdo8WSnoof1K7T",
    //         "VOy9hPvV9QLC9hXpkSKcXLaXABnb6OPNv9t2z/ngrgLISY2K93h/LJf/NYhmxMwZ",
    //         "O3DsVvUNHZr/mcoKaLavnXJtrd5Dvdekee0YidmzfKmNn2c8yVWIIjF3+fqtfndF",
    //         "BPRmsTYWMZUOL3DLQ4wkuqj8mLV5aoC2HWmkJ/+U/MltAiKFwSUvh2omp1Lme+Sr",
    //         "qibtSYqhiXudOv4kToFBWcw4f1c7WafuMl9ALRax/APV+aj+ZWNNMRxDi9ze/Bgk",
    //         "Q6ADv+wwWFDg9nYLpIhl4UzgAkMI4pm+vCS+8C+TDw9N0G80cYWp4xI6ZXrzXpek",
    //         "az2mw7KDJYxX6+EHCBzrj9ajo2eofc0c5O8vftHNSiWPk9cwqSpLY8nrBdKMAjma",
    //         "tClaKz8eaRUZ6nMvtnIwuyRF8/v0wJxL8kRYv94AQM2L7hwWUCXfqrflnwARAQAB",
    //         "/gcDAihjnkFpS3rj50W1KZnJPRgh7SmFFWVe91RKX9ocBLLgARH+EVQvPE37JDVn",
    //         "CZEh7A73dVTUz9lg9krx9rG/qUHRO4vFzkftZGXXZxcH0DfD2EdxCpMYgWfpptrq",
    //         "3a5jXKWq3QIHJVsaA1sFUsl4Q61z8Z+U7NHDwuilV/1OKkXNOaaber3ou++Ch+Ck",
    //         "5ZgWyRBfpgtJqcfxPXozG94vnAXAGr32672DeehIMD30wc4xfSjLBOqxDnPpnO/X",
    //         "+UonkuslfhpRIVdgcFWNq1Rty0upTe2yZGl/F0r/8y9QmqRzg1P/XNLGFRvlVofp",
    //         "ZsQI5xNYjAJ5tEIXYKxFsCoAoxsUPsU8ORHgk33QP/tPeh6Eb/mffZwcjiXjRABt",
    //         "H+4m42ljxlXldbtPty+X5SQTo0OwaUMx54nmLuJkb8lBETJ7DIxG3uM38jTzVohU",
    //         "+oFzHDdAP4gNgJmXToodTvYAhWqeXFlSm9GrwVjmyZubItBGaGNbxfA6GnAQdbvt",
    //         "hUife1noCcH6Q8aNTnkdsLSRT59QYQnR98f6md8bi3567pFgYQ4HT/Q1q/CTeVsp",
    //         "vZ9Dgqv2BcAVtJTdXC+U8SO6b3u5NxFVu+ThHi3TNjCtGaOiGnMKX4lwHA9kAuMj",
    //         "nx8Gf6oUdQchJp40NQmCbySRR97trMCYpi2WEnpegLT7Pa2Djv/jqDV9em6uGPWz",
    //         "8qoU5LWXBP2+6uQA0arFN7qE1mCcMMvw790pFFzBcq+GSrtCdBsA8+8KBriKUhPK",
    //         "PX17mCKiVGAjeseLqe9IPV/lryXOItg1ibVZTMiWggVs3C9PlfHRYhV/Q2U1wSXa",
    //         "RSyMat3CTdmfbQtoZ5WRPht4ReO0NGGrJ5jS0NT7G8qI4+IOQAKRL4vuRapxZTQx",
    //         "X/R5hTGxSvtirnIzBI8ePnkgt7N2DhJpSj+sqQhi3iv5LRhIRqJ+9iIY2DdiI55U",
    //         "TzQD8DNTYAva4jTvFRAY+KIuiSFyy/wqsbqfb3iZror05MRbjY8MKt6tApdgDRKp",
    //         "aha3dBIpPT/2up4kpInPTMaCRyblY3Vg6xydFETqA2I7K1Kmda0Bl5yNzxTmCXIN",
    //         "yMmrW9IB0gZYi088lWEVBUcBlZH0SAOCyoZ4ow+JahP2RQ4QKu7zunjsR30TgFm4",
    //         "NQ5meu7/01r9YP3CQcvuOt56OD+c8JXDggoElROVxMOAsHHZvQ4eFqN6o8GkUEIF",
    //         "Skt5WkuJ+hJpujTDB4sfgm+7K7ofzBL92qfJNKBSRa4gRfQqibBMGC/ThpVf0WPT",
    //         "vQv3QTK6zFXfPnkqYRP6MPj4EqNwjy1D+B8YzFKGZWehGWu+EXtlom2FW+kZNp8M",
    //         "O/eMkJed0+ys2cBsibewu67aFN5kgpcWCR6moLRicJGiyV3ftmaE+ZZFLHZjHPr/",
    //         "8SG6nZTjcI8QIrkBlmx2yZjLVW/Y70DSvJlzC2DKLrEo9cUmREIaxyEUrXdSIO8s",
    //         "r2kI/46dHSuJEWO2NHGyBFPdbEh9ULtBAp+0oKPTUlwCfLxlV1SudzqHNu+zCsQf",
    //         "e47ZueYPwRVNaBIGK14MRky7zlFsQ5LBbHukxaF1wlgZmiJCLUWLtsMClPubeP33",
    //         "bjBDouYsLbZmVrNGdvKLG5KsW2vYuG+/pB9ypwnsxbENjS3if59H19OjhEsXA85N",
    //         "ARXtZSCmv3zeIIQfWG8feQ5mZNn9nGvnzt+eDUtES+T3pJiyZ27zyf93HDVb4Mfq",
    //         "RWT99t59a+TlzLUIp+lj+QalUfXCc9bfoINIGc8oMpn3dnNImPXSXRG0I0N5YmVy",
    //         "Q2hlZiBwdyA0MDk2IDx0b2J5QHRvYnkuY29kZXM+iQI3BBMBCAAhBQJYvueGAhsD",
    //         "BQsJCAcCBhUICQoLAgQWAgMBAh4BAheAAAoJEGSKVQ55krJeMowP/36BFD0Whupz",
    //         "FR/GfR1kMO6K9hMqyBmAhpM5X+0QaP1aGE1/agjwjip4RVjtg3/KgdyVWNsq8Orb",
    //         "uGeq1sLgQtSWf07tI1v4uLl6MGHgs6iSti/ivMMHmKHu9KGx4IAnItyimnJarzd9",
    //         "qEKtH+p3q5mwoSqQGBqqafzE057BAZQRpsBSf8D51GADgcto2cibkPRq05mGrhhy",
    //         "mpUm254VKYTmrnSV9sEGvOXQasZm6V4CjePrZBvW5Idr6dcbDksq1x3ovKh3HjOg",
    //         "M2HHom4vPl5ZnWY+O2wR03lJ2xy81cj3ZD8AddJJHZ1VLfa3qdOL5K+ejlGb5dV6",
    //         "mShPncR5gRljvWm1+Aka0pZHAI+/TYIISh4IETwGpWsSAednao15De4EduCqqGmm",
    //         "WU38Sqn5kyVkS8AbcBt1VvucUDYT3eTbVl6odp7mwiJ80ZmAakG6LUzDY2uN3lrD",
    //         "mJzs2tB9ee+hI9L5+HaNsdEmk+dsiK50qMZxOVoji265y6f8E9PdeFXbdGhBXk0r",
    //         "0BtouKr7EJRGanB6Xu+A2lp1uc8CWzDSGcwgcHp5lpX7phcEcv0BZkiWKh0tdgPK",
    //         "WczPS7FAgBl1aXbyE27Uu00y+dn0MZ/RZfZ3/ErHEO8hT5dw3ilAUdLjANTypU9z",
    //         "971K+e6nY1pJpJsjBw8EDcc7U5PPFFa0nQdGBFi+54YBEADPeXZ9cwEjlM1cp7Jt",
    //         "fIrh5GUEheu/OgS38dxgQ5L8uZvwPwKrnrO0exL222WYnRgdR7GNkNlLr428eizf",
    //         "n/EUbkp5FEJ+ld3Jxx00OXRip8CJ8OXqf5Osppw82v8PQNNNVOOt0onVyR6s16gl",
    //         "QGeTmPwL7Juvm452jztIgAGNZInBHobvuScKbDMO0Gk1r7Bbt4SCqzBQOIKRkH3l",
    //         "4JQguUffw17XDibY0h5JDz6EL/SdaAco5PogEcHiTUIm4yP7NtQtU5LtEch6Qmyo",
    //         "3fIJxpRTSrpCBelzIsa8W3SL4ZYqaPR34pFKOSnnA4BJ636anyTibzRobcHyyqGR",
    //         "RIMItY2/9Pxq2b/F0Z1Tz/HR6PH/Xs7p9oSHS9mns8QCYWG9wLPWUvdv7FWksGxY",
    //         "1Nqg903U11N/58knqjsnBV7F98Js8wkDxTKDFhz2pzl7P3VTfcDr95JD2CcHzAeR",
    //         "diiDwTr3m0CGQez53CLs9GqeeBA/Cjeo3zXOnINRhyWOo2HJVMKUwQd+JzHnw6G6",
    //         "gOeoqcjvxOW9Ltk76S24BVhA8nTckhNrLzXHuRGG7P6KkSKOvXZXC5FU+Ch/jzbu",
    //         "M+5B0T+8rrRJ6++GWAAGp3jbLrfQfPKJUuR6swt2v4eTiotAtnjww4C2guQ8nDVT",
    //         "3sGZeaZhrS1zdKuOTl/UjvdvywARAQAB/gcDAkXjMtWz9cQV5xP+xcpV8EjTKFfy",
    //         "HaE9FBzSRSMHH0mLzSfABYk0ATAfXXPUvbpqN09a/gBLFnJ/VBwsAJstr+iFQgYs",
    //         "iMNAQxsR6mfCFFvHCAgADK9xTw8k7Un+5LrCj4Uu24h4ua2Kahgil5d4uSsjf7yr",
    //         "UJgX0fAJSYOE7UhNQKPMm9Zjm/+KEFgOC+CpXVEzw4iac5wFD80FpdlGFScsBua3",
    //         "o6IVRoadqZkxVWCCxzhdPwzuyZKZGxybMZhwhWPEBIhOiI/Xns1YcKQ8LS6iWTrW",
    //         "bVwgRbCwyQdf/sEDBA+fJPgA5DXvIOfitrlUttJK+oGOem9bn9lPrmrLUMA5OQXe",
    //         "4ZD7asKJg/BDdgdHaD55fsyfHiYEmnl1QlgrcO0/he60dQJv4/wfDvxCt8YmoAyt",
    //         "OmtxL/H98av6Gno25dcM6iJCXi6S66pODTq8q3j7495HB31xV5Q0v4ThJo8m/8cz",
    //         "iRu3YlWkDiDV4oex4xX8To5R40QyEWyMw8xal385UClA8MBycGmbwmubflJbrNHO",
    //         "m78U61dzGxQmihpkOSyyZUhHornFV4lIK0Czd0k838NMUcZxUpzFqctAr8C/mViM",
    //         "6l31sTYLRjJ9U4QIbBYYxWhI7JYa5ZPveiC5XOfH4QBehP1QqjEAB5+1EzWpfwHA",
    //         "8iwuvigNtP2kCBJn0JHPHclx8/S+I5g3uTkKULfoBKs5evsIqIlPmrvhup30TPyH",
    //         "Vkd8oxbEAzKUZzQD3mA/crrBwDNVS5inqDgu34Exki6wMw9oTRmFZ5NjnCKZsUNS",
    //         "E+uH9xbgIZwdc3WHKAsP/hjYfO6glfClkG9uK/tXgrLJGlqAWNoSOa60VbMv8cp1",
    //         "2UthK8+GNDVX4lJ/k5u+Gt29SSRuQElkJKShw9XTePXJ5Nxup+WUtQuzdPOJfc7D",
    //         "ydC/PXJ7ikrBDAuNbH/+koCu4p+43z7DgbgYN/HnDGGJ3poq0QeeHbU0zmTFv0h9",
    //         "oVsJHeCe5RkBK6kX7Ax5M4ESCTMZcgJab70UDssohQUM4mj4woCdwGs/igPuGlcy",
    //         "XLKo5ep4XwdHuzgryE5YR1jRIiSROnj8hDCfRZ9iZUgr3kOZ8IcNZtfF5BgzZQ6i",
    //         "FM24KAbPWhxw3/eT9j46FAlSQHJur6NudpI9gy+k32EKBcRsGBkVvmD5G7nHxseW",
    //         "+O2rC5YG82B/EuWc6zFXYbLEHHzUeDH90lNiVqkUswbI+NIRgn2d2sUrpAMw6Lve",
    //         "JLljjcTjJcKqDWV5JARnxw0K/EklST3j2UWXdbidxC15enJtjM/CXZBYI3L12mTU",
    //         "pumpV4qF69bjfZwIGRW4+cRQFqf+Ppj71QwrO2T8XS39Cz96Wm86DTPqM1oelZHy",
    //         "Vo43PGXCi68PxFAcoXko9JH21wLeNenbjEpoLkbKZr0L27O05E3taipihnSJalyu",
    //         "jSC0EKAz6e766SCHJcbN4Ht2xD1MhHWSFq5EGlDR3C1nXLeZS6S/Bdg2tfutegr5",
    //         "bd/PZzkHClATZD6HJONmrBW8CpbGDwXPvWTNlXePKgAylPA9IQu+4XNC8MiLY7+n",
    //         "dsZX0rc+Zi0TUNhh7JJNHl44q2ieEzlx/FqXHJ6gPa5375JtYCyYNPwGI2nq0TBb",
    //         "Q19dG65PilBZ8aOLfhZMTe8gKfA61NaZIxBs0dON6QUyFEIg3edzAO/csbxvBLgs",
    //         "nC1PAcqysizcaRXZvcPig9g02OygSiymoxP4PqDv0EoKt6+9Ch8CBbXdGhXSKlWB",
    //         "1u33hhsvxnsPIMiGr3RF/YuJAh8EGAEIAAkFAli+54YCGwwACgkQZIpVDnmSsl5e",
    //         "EBAAhWri0PZqLU70YlJFmhh3jDUcUfytlJlgLRnMT2NzYkhW4EZceJ+O/hg+Skgw",
    //         "I0NMpcqcSjNVxTghQjLV7HJysPn8/JasIba4Iu1UHCPWLh6TTXZdy/qM2BPel1Tv",
    //         "ke1SbfKa6uw5Kc1uQgEnest+vHsolaQW7XxAbsy2dpflvZTPhI9K76/ywbKBiLMy",
    //         "dhRDhXvXqJJynOihQDIs0Kr7M2ksg6vMovG9oZKfCQjNpBOxSjcTkOnt6fmixQ6y",
    //         "yosXlFioKQLDXDSfgRt5rriE/LIDuYPyruS6KKiacw7QuGp4wtn1CQjXxAA7yMi4",
    //         "lTl88u2pNKO+jPSBtpIVtdSbYhCqSYYmkYZyvmz6tEYoLZ1St1Od+Foix68NoOeg",
    //         "XXy4CFz6sUPcmf+L6vp51qnPlNVVBvWC76YVrsNfW8J1OrKMNYug1CBF7r1dgl7N",
    //         "QsjXp0ZuZEAjaLRHSnYlB5vPlRg6mVgDORhv3Tkn59JCmgnC2WOb0iuO+TEOKKqT",
    //         "LhEkCXamkkKFCASpcQm7ERSmK1pwO0l3AVCKvBIWy3zX23onsb90th7FgvlLIG5B",
    //         "Nqk5T7IygucojZugFWHfmNY4ShuUd5iyERGlI3xEBUvTHTQ8udRXJWz71g1vaIJg",
    //         "NojNQbHJeIwNHumM2qJHpdyoKZZOOxA4RP3FC8Q8foAsYT8=",
    //         "=6KWj",
    //         "-----END PGP PRIVATE KEY BLOCK-----",
    //     ].join("\n"),
    // },
];

["", "hello world"].forEach(function(input) {
    TestRegister.addTests(
        PGP_TEST_KEY_PAIRS.map(function(keyPair) {
            var testName = "PGP encrypt, PGP decrypt ($pw, $ks) '$input'";
            testName = testName.replace("$ks", keyPair.size);
            testName = testName.replace("$pw", keyPair.password ? "pw" : "no pw");
            testName = testName.replace("$input", input);

            return {
                name: testName,
                input: input,
                expectedOutput: input,
                recipeConfig: [
                    {
                        op: "PGP Encrypt",
                        args: [keyPair.pub],
                    },
                    {
                        op: "PGP Decrypt",
                        args: [keyPair.sec, keyPair.password],
                    },
                ],
            };
        })
    );
});

TestRegister.addTests([{
    name: "PGP encrypt, PGP Decrypt: fails when incorrect password, empty string (1024)",
    input: "",
    expectedError: true,
    recipeConfig: [
        {
            op: "PGP Encrypt",
            args: [PGP_TEST_KEY_PAIRS[1].pub],
        },
        {
            op: "PGP Decrypt",
            args: [PGP_TEST_KEY_PAIRS[1].sec, "gibberish"],
        },
    ],
}]);

TestRegister.addTests([{
    name: "PGP encrypt, PGP Decrypt: fails when incorrect password, hello world (1024)",
    input: "hello world",
    expectedError: true,
    recipeConfig: [
        {
            op: "PGP Encrypt",
            args: [PGP_TEST_KEY_PAIRS[1].pub],
        },
        {
            op: "PGP Decrypt",
            args: [PGP_TEST_KEY_PAIRS[1].sec, "gibberish"],
        },
    ],
}]);

["hello world"].forEach(function(input) {
    [
        [PGP_TEST_KEY_PAIRS[0], PGP_TEST_KEY_PAIRS[1]],
        [PGP_TEST_KEY_PAIRS[1], PGP_TEST_KEY_PAIRS[0]],
    ].forEach(function(pairOfKeyPairs) {
        var alice = pairOfKeyPairs[0];
        var bob = pairOfKeyPairs[1];

        var testName = "PGP Sign ($alice), PGP Verify ($bob) '$input'";
        testName = testName.replace("$alice", alice.name);
        testName = testName.replace("$bob", bob.name);
        testName = testName.replace("$input", input);

        TestRegister.addTests([{
            name: testName,
            input: input,
            expectedOutput: [
                "Verified: true",
                "Key ID: " + alice.keyID,
                "Encrypted for: " + bob.name,
                "Signed on: ",
                "Signed by: " + alice.name,
                "Signed with: ",
                "\n",
                input,
            ].join("\n"),
            recipeConfig: [
                {
                    op: "PGP Sign",
                    args: [bob.pub, alice.sec, alice.password],
                },
                {
                    op: "PGP Verify",
                    args: [alice.pub, bob.sec, bob.password, true],
                },
            ],
        }]);
    });
});

["hello world"].forEach(function(input) {
    [
        [PGP_TEST_KEY_PAIRS[0], PGP_TEST_KEY_PAIRS[1]],
        [PGP_TEST_KEY_PAIRS[1], PGP_TEST_KEY_PAIRS[0]],
    ].forEach(function(pairOfKeyPairs) {
        var alice = pairOfKeyPairs[0];
        var bob = pairOfKeyPairs[1];

        var testName = "PGP Sign ($alice), PGP Verify ($bob) '$input' (message hidden)";
        testName = testName.replace("$alice", alice.name);
        testName = testName.replace("$bob", bob.name);
        testName = testName.replace("$input", input);

        TestRegister.addTests([{
            name: testName,
            input: input,
            expectedOutput: [
                "Verified: true",
                "Key ID: " + alice.keyID,
                "Encrypted for: " + bob.name,
                "Signed on: ",
                "Signed by: " + alice.name,
                "Signed with: ",
                "\n",
                "",
            ].join("\n"),
            recipeConfig: [
                {
                    op: "PGP Sign",
                    args: [bob.pub, alice.sec, alice.password],
                },
                {
                    op: "PGP Verify",
                    args: [alice.pub, bob.sec, bob.password, false],
                },
            ],
        }]);
    });
});

["", "hello world"].forEach(function(input) {
    TestRegister.addTests(
        PGP_TEST_KEY_PAIRS.map(function(keyPair) {
            var testName = "PGP Sign Cleartext, PGP Verify Cleartext ($pw, $ks) '$input'";
            testName = testName.replace("$ks", keyPair.size);
            testName = testName.replace("$pw", keyPair.password ? "pw" : "no pw");
            testName = testName.replace("$input", input);

            return {
                name: testName,
                input: input,
                expectedOutput: [
                    "Verified: true",
                    "Key ID: " + keyPair.keyID,
                    "Signed on: ",
                    "Signed by: " + keyPair.name,
                    "Signed with: ",
                    "\n",
                    input,
                ].join("\n"),
                recipeConfig: [
                    {
                        op: "PGP Sign Cleartext",
                        args: [keyPair.sec, keyPair.password],
                    },
                    {
                        op: "PGP Verify Cleartext",
                        args: [keyPair.pub, true],
                    },
                ],
            };
        })
    );
});

["", "hello world"].forEach(function(input) {
    TestRegister.addTests(
        PGP_TEST_KEY_PAIRS.map(function(keyPair) {
            var testName = "PGP Sign Cleartext, PGP Verify Cleartext ($pw, $ks) '$input' (message hidden)";
            testName = testName.replace("$ks", keyPair.size);
            testName = testName.replace("$pw", keyPair.password ? "pw" : "no pw");
            testName = testName.replace("$input", input);

            return {
                name: testName,
                input: input,
                expectedOutput: [
                    "Verified: true",
                    "Key ID: " + keyPair.keyID,
                    "Signed on: ",
                    "Signed by: " + keyPair.name,
                    "Signed with: ",
                    "\n",
                    "",
                ].join("\n"),
                recipeConfig: [
                    {
                        op: "PGP Sign Cleartext",
                        args: [keyPair.sec, keyPair.password],
                    },
                    {
                        op: "PGP Verify Cleartext",
                        args: [keyPair.pub, false],
                    },
                ],
            };
        })
    );
});

TestRegister.addTests(CYBERCHEF_GENERATED_KEY_PAIRS.map(function(keyPair) {
    var testName = "PGP Remove ASCII Armor, PGP Add ASCII Armor: Public Key '$name'";
    testName = testName.replace("$name", keyPair.name);

    return {
        name: testName,
        input: keyPair.pub,
        expectedOutput: keyPair.pub,
        ignoreWhitespace: true,
        recipeConfig: [
            {
                op: "PGP Remove ASCII Armor",
                args: [],
            },
            {
                op: "PGP Add ASCII Armor",
                args: ["Public key"],
            },
        ],
    }
}));

TestRegister.addTests(CYBERCHEF_GENERATED_KEY_PAIRS.map(function(keyPair) {
    var testName = "PGP Remove ASCII Armor, PGP Add ASCII Armor: Private Key '$name'";
    testName = testName.replace("$name", keyPair.name);

    return {
        name: testName,
        input: keyPair.sec,
        expectedOutput: keyPair.sec,
        ignoreWhitespace: true,
        recipeConfig: [
            {
                op: "PGP Remove ASCII Armor",
                args: [],
            },
            {
                op: "PGP Add ASCII Armor",
                args: ["Private key"],
            },
        ],
    }
}));

CYBERCHEF_GENERATED_KEY_PAIRS.forEach(function(keyPair) {
    TestRegister.addTests(keyPair.messages.map(function(encryptedMessage, messageIndex) {
        var testName = "PGP Remove ASCII Armor, PGP Add ASCII Armor: Message $message '$name'";
        testName = testName.replace("$message", messageIndex);
        testName = testName.replace("$name", keyPair.name);

        return {
            name: testName,
            input: encryptedMessage,
            expectedOutput: encryptedMessage,
            ignoreWhitespace: true,
            recipeConfig: [
                {
                    op: "PGP Remove ASCII Armor",
                    args: [],
                },
                {
                    op: "PGP Add ASCII Armor",
                    args: ["Message"],
                },
            ],
        };
    }));
});